Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.lang
Class Package

    java.lang.Object
      |
      +--java.lang.Package

public class Package
extends Object

`Package` objects contain version information about the implementation and specification of a Java package. This versioning information is retrieved and made available by the classloader that loaded the class(es). Typically, it is stored in the manifest that is distributed with the classes.

The set of classes that make up the package may implement a particular specification and if so the specification title, version number, and vendor strings identify that specification. An application can ask if the package is compatible with a particular version, see the `isCompatibleWith` method for details.

Specification version numbers use a "Dewey Decimal" syntax that consists of positive decimal integers separated by periods ".", for example, "2.0" or "1.2.3.4.5.6.7". This allows an extensible number to be used to represent major, minor, micro, etc versions. The version number must begin with a number.

The implementation title, version, and vendor strings identify an implementation and are made available conveniently to enable accurate reporting of the packages involved when a problem occurs. The contents all three implementation strings are vendor specific. The implementation version strings have no specified syntax and should only be compared for equality with desired version identifers. Within each classloader all classes from the same java package have the same Package object. The static methods allow a package to be found by name or the set of all packages known to the current class loader to be found.

See Also:
  `ClassLoader.definePackage(java.lang.String, java.lang.String, java.lang.String, java.lang.String, java.lang.String, java.lang.String, java.lang.String, java.net.URL)`

Method Summary
`String` | `getImplementationTitle()` Return the title of this package.
`String` | `getImplementationVendor()` Returns the name of the organization, vendor or company that provided this implementation.
`String` | `getImplementationVersion()` Return the version of this implementation.
`String` | `getName()` Return the name of this package.
`static Package` | `getPackage(String name)` Find a package by name in the callers classloader.
`static Package[]` | `getPackages()` Get all the packages currently known for the caller's class loader.
`String` | `getSpecificationTitle()` Return the title of the specification that this package implements.
`String` | `getSpecificationVendor()` Return the name of the organization, vendor, or company that owns and maintains the specification of the classes that implement this package.
`String` | `getSpecificationVersion()` Returns the version number of the specification that this package implements.
`int` | `hashCode()` Return the hashcode computed from the package name.
`boolean` | `isCompatibleWith(String desired)` Compare this package's specification version with a desired version.
`boolean` | `isSealed()` Returns true if this package is sealed.
`boolean` | `isSealed(URL url)` Returns true if this package is sealed with respect to the specified code source url.
`String` | `toString()` Returns the string representation of this Package.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, notify, notifyAll, wait, wait, wait`

Method Detail

### getName

    public String getName()

  Return the name of this package.
  Returns:
    The name of this package using the Java language dot notation for the package. i.e java.lang

### getSpecificationTitle

    public String getSpecificationTitle()

  Return the title of the specification that this package implements.
  Returns:
    the specification title, null is returned if it is not known.

### getSpecificationVersion

    public String getSpecificationVersion()

  Returns the version number of the specification that this package implements. This version string must be a sequence of positive decimal integers separated by "."'s and may have leading zeros. When version strings are compared the most significant numbers are compared.
  Returns:
    the specification version, null is returned if it is not known.

### getSpecificationVendor

    public String getSpecificationVendor()

  Return the name of the organization, vendor, or company that owns and maintains the specification of the classes that implement this package.
  Returns:
    the specification vendor, null is returned if it is not known.

### getImplementationTitle

    public String getImplementationTitle()

  Return the title of this package.
  Returns:
    the title of the implementation, null is returned if it is not known.

### getImplementationVersion

    public String getImplementationVersion()

  Return the version of this implementation. It consists of any string assigned by the vendor of this implementation and does not have any particular syntax specified or expected by the Java runtime. It may be compared for equality with other package version strings used for this implementation by this vendor for this package.
  Returns:
    the version of the implementation, null is returned if it is not known.

### getImplementationVendor

    public String getImplementationVendor()

  Returns the name of the organization, vendor or company that provided this implementation.
  Returns:
    the vendor that implemented this package..

### isSealed

    public boolean isSealed()

  Returns true if this package is sealed.
  Returns:
    true if the package is sealed, false otherwise

### isSealed

    public boolean isSealed(URL url)

  Returns true if this package is sealed with respect to the specified code source url.
  Parameters:
    `url` - the code source url
  Returns:
    true if this package is sealed with respect to url

### isCompatibleWith

    public boolean isCompatibleWith(String desired)
                             throws NumberFormatException

  Compare this package's specification version with a desired version. It returns true if this packages specification version number is greater than or equal to the desired version number.

  Version numbers are compared by sequentially comparing corresponding components of the desired and specification strings. Each component is converted as a decimal integer and the values compared. If the specification value is greater than the desired value true is returned. If the value is less false is returned. If the values are equal the period is skipped and the next pair of components is compared.

  Parameters:
    `desired` - the version string of the desired version.
  Returns:
    true if this package's version number is greater than or equal to the desired version number
  Throws:
    `NumberFormatException` - if the desired or current version is not of the correct dotted form.

### getPackage

    public static Package getPackage(String name)

  Find a package by name in the callers classloader. The callers classloader is used to find the package instance corresponding to the named class. If the callers classloader is null then the set of packages loaded by the system classloader is searched to find the named package.

  Packages have attributes for versions and specifications only if the class loader created the package instance with the appropriate attributes. Typically, those attributes are defined in the manifests that accompany the classes.

  Parameters:
    `name` - a package name, for example, java.lang.
  Returns:
    the package of the requested name. It may be null if no package information is available from the archive or codebase.

### getPackages

    public static Package[] getPackages()

  Get all the packages currently known for the caller's class loader. Those packages correspond to classes loaded via or accessible by name to that class loader. If the caller's class loader is the bootstrap classloader, which may be represented by `null` in some implementations, only packages corresponding to classes loaded by the bootstrap class loader will be returned.
  Returns:
    a new array of packages known to the callers classloader. An zero length array is returned if none are known.

### hashCode

    public int hashCode()

  Return the hashcode computed from the package name.
  Overrides:
    `hashCode` in class `Object`
  Returns:
    the hodecode computed from the package name.

### toString

    public String toString()

  Returns the string representation of this Package. Its value is the string "package " and the package name. If the package title is defined it is appended. If the package version is defined it is appended.
  Overrides:
    `toString` in class `Object`
  Returns:
    the string representation of the package.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.